CREATE OR REPLACE
PROCEDURE EXP_FILIOPELOG_NGD
IS
  V_CHAVE        VARCHAR2(300);
  V_ERRO         VARCHAR2(300);
  V_DSOBSFILIAL  PARCMPSUP.DSOBSFILIAL%TYPE;
  V_CONTADOR     FLOAT := 0;
BEGIN
   FOR C_FILIALOL IN
      (SELECT CDFILIAL CDFILIOPELOG, NMFILIAL
         FROM FILIAL
        WHERE NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
          AND NVL(FILIAL.IDFUNCAOFILI, 'T') = 'O'
          AND NVL(FILIAL.USR_NGD_INTEGRADO, 'N') = 'N')
   LOOP
      V_CONTADOR := V_CONTADOR + 1;
      IF V_CONTADOR >= 500 THEN
         V_CONTADOR := 0;
         COMMIT;
      END IF;
      SELECT NVL(MAX(USR_FILIOPELOG_NGD.CDFILIOPELOG), '')
        INTO V_CHAVE
        FROM USR_FILIOPELOG_NGD
       WHERE USR_FILIOPELOG_NGD.CDFILIOPELOG = C_FILIALOL.CDFILIOPELOG;
      SELECT MAX(DSOBSFILIAL)
        INTO V_DSOBSFILIAL
        FROM PARCMPSUP
       WHERE CDFILIAL = C_FILIALOL.CDFILIOPELOG;
      IF V_DSOBSFILIAL IS NOT NULL THEN
         V_DSOBSFILIAL := SUBSTR(V_DSOBSFILIAL, 1, 200);
      END IF;
      BEGIN
         IF V_CHAVE = '' THEN
            INSERT
             INTO USR_FILIOPELOG_NGD(CDFILIOPELOG, NMFILIAL, CDGRUPFILI1, CDGRUPFILI2, CDGRUPFILI3, CDGRUPFILI4,
                                     IDVASOCOMUNICA, IDFREQUENCIA, IDMAXCAPACIDADE, OBSFILIAL,
                                     IDSTATUSFILI, TPINTERFACE, DTINTERFACEORI,	DTINTERFACEDEST,	STATUS)
            VALUES (C_FILIALOL.CDFILIOPELOG, C_FILIALOL.NMFILIAL, 'ND', 'ND', 'ND', 'ND',
                    0, 1, 0, V_DSOBSFILIAL,
                    'ATIVO',	'I', 	SYSDATE,	NULL,	'1');
         ELSE
            UPDATE USR_FILIOPELOG_NGD
               SET NMFILIAL           = C_FILIALOL.NMFILIAL,
                   TPINTERFACE        = 'A',
                   DTINTERFACEORI     = SYSDATE,
                   DTINTERFACEDEST    = NULL,
                   STATUS             = '1'
             WHERE USR_FILIOPELOG_NGD.CDFILIOPELOG = C_FILIALOL.CDFILIOPELOG;
         END IF;
         UPDATE USR_LOG_NGD
            SET DTLOG      = SYSDATE,
                STATUS     = '0',
                OBSSTATUS  = NULL
          WHERE IDPROCESSO = 'USR_FILIOPELOG_NGD'
            AND IDPESQITEM = C_FILIALOL.CDFILIOPELOG;
         IF SQL%NOTFOUND THEN
            INSERT
              INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
            VALUES ('USR_FILIOPELOG_NGD', SYSDATE, '0', NULL, C_FILIALOL.CDFILIOPELOG);
         END IF;   
         UPDATE FILIAL
            SET USR_NGD_INTEGRADO = 'S'
          WHERE FILIAL.CDFILIAL   = C_FILIALOL.CDFILIOPELOG
            AND NVL(USR_NGD_INTEGRADO, 'N') = 'N';
      EXCEPTION
         WHEN OTHERS THEN BEGIN
            V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
            UPDATE USR_LOG_NGD
               SET DTLOG     = SYSDATE,
                   STATUS    = '1',
                   OBSSTATUS = V_ERRO
             WHERE IDPROCESSO = 'USR_FILIOPELOG_NGD'
               AND IDPESQITEM = C_FILIALOL.CDFILIOPELOG;
            IF SQL%NOTFOUND THEN
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_FILIOPELOG_NGD', SYSDATE, '1', V_ERRO, C_FILIALOL.CDFILIOPELOG);
            END IF;   
         END;
      END;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXP_FILIOPELOG_NGD','6.37.015'); END;
/
